Package weka.clusterers.forOPTICSAndDBScan.DataObjects

# Class ManhattanDataObject

java.lang.Object
weka.clusterers.forOPTICSAndDBScan.DataObjects.ManhattanDataObject

All Implemented Interfaces:
  `Serializable`, `DataObject`, `RevisionHandler`

public class ManhattanDataObject extends Object implements DataObject, Serializable, RevisionHandler

ManhattanDataObject.java
Authors: Rainer Holzmann, Zhanna Melnikova-Albrecht, Matthias Schubert
Date: Aug 19, 2004
Time: 5:50:22 PM
$ Revision 1.4 $

Version:
  $Revision: 10571 $
Author:
  Matthias Schubert (schubert@dbs.ifi.lmu.de), Zhanna Melnikova-Albrecht (melnikov@cip.ifi.lmu.de), Rainer Holzmann (holzmann@cip.ifi.lmu.de)
See Also:
  - Serialized Form

## Field Summary

### Fields inherited from interface weka.clusterers.forOPTICSAndDBScan.DataObjects.DataObject

`NOISE, UNCLASSIFIED, UNDEFINED`

## Constructor Summary

Constructors
Constructor
Description
`ManhattanDataObject(Instance originalInstance, String key, Database database)`
Constructs a new DataObject.

## Method Summary

Modifier and Type
Method
Description
`double`
`distance(DataObject dataObject)`
Calculates the manhattan-distance between dataObject and this.dataObject
`boolean`
`equals(DataObject dataObject)`
Compares two DataObjects in respect to their attribute-values
`int`
`getClusterLabel()`
Returns the clusterID, to which this DataObject belongs to
`double`
`getCoreDistance()`
Returns the coreDistance for this dataObject
`Instance`
`getInstance()`
Returns the original instance
`String`
`getKey()`
Returns the key for this DataObject
`double`
`getReachabilityDistance()`
Returns the reachabilityDistance for this dataObject
`String`
`getRevision()`
Returns the revision string.
`boolean`
`isProcessed()`
Gives information about the status of a dataObject
`void`
`setClusterLabel(int clusterID)`
Sets the clusterID (cluster), to which this DataObject belongs to
`void`
`setCoreDistance(double c_dist)`
Sets a new coreDistance for this dataObject
`void`
`setKey(String key)`
Sets the key for this DataObject
`void`
`setProcessed(boolean processed)`
Marks this dataObject as processed
`void`
`setReachabilityDistance(double r_dist)`
Sets a new reachability-distance for this dataObject
`String`
`toString()`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### ManhattanDataObject

public ManhattanDataObject(Instance originalInstance, String key, Database database)
Constructs a new DataObject. The original instance is kept as instance-variable

Parameters:
  `originalInstance` - the original instance

## Method Details

### equals

public boolean equals(DataObject dataObject)
Compares two DataObjects in respect to their attribute-values

Specified by:
  `equals` in interface `DataObject`
Parameters:
  `dataObject` - The DataObject, that is compared with this.dataObject; now assumed to be of the same type and with the same structure
Returns:
  Returns true, if the DataObjects correspond in each value, else returns false

### distance

public double distance(DataObject dataObject)
Calculates the manhattan-distance between dataObject and this.dataObject

Specified by:
  `distance` in interface `DataObject`
Parameters:
  `dataObject` - The DataObject, that is used for distance-calculation with this.dataObject now assumed to be of the same type and with the same structure
Returns:
  double-value The manhattan-distance between dataObject and this.dataObject NaN, if the computation could not be performed

### getInstance

public Instance getInstance()
Returns the original instance

Specified by:
  `getInstance` in interface `DataObject`
Returns:
  originalInstance

### getKey

public String getKey()
Returns the key for this DataObject

Specified by:
  `getKey` in interface `DataObject`
Returns:
  key

### setKey

public void setKey(String key)
Sets the key for this DataObject

Specified by:
  `setKey` in interface `DataObject`
Parameters:
  `key` - The key is represented as string

### setClusterLabel

public void setClusterLabel(int clusterID)
Sets the clusterID (cluster), to which this DataObject belongs to

Specified by:
  `setClusterLabel` in interface `DataObject`
Parameters:
  `clusterID` - Number of the Cluster

### getClusterLabel

public int getClusterLabel()
Returns the clusterID, to which this DataObject belongs to

Specified by:
  `getClusterLabel` in interface `DataObject`
Returns:
  clusterID

### setProcessed

public void setProcessed(boolean processed)
Marks this dataObject as processed

Specified by:
  `setProcessed` in interface `DataObject`
Parameters:
  `processed` - True, if the DataObject has been already processed, false else

### isProcessed

public boolean isProcessed()
Gives information about the status of a dataObject

Specified by:
  `isProcessed` in interface `DataObject`
Returns:
  True, if this dataObject has been processed, else false

### setCoreDistance

public void setCoreDistance(double c_dist)
Sets a new coreDistance for this dataObject

Specified by:
  `setCoreDistance` in interface `DataObject`
Parameters:
  `c_dist` - coreDistance

### getCoreDistance

public double getCoreDistance()
Returns the coreDistance for this dataObject

Specified by:
  `getCoreDistance` in interface `DataObject`
Returns:
  coreDistance

### setReachabilityDistance

public void setReachabilityDistance(double r_dist)
Sets a new reachability-distance for this dataObject

Specified by:
  `setReachabilityDistance` in interface `DataObject`

### getReachabilityDistance

public double getReachabilityDistance()
Returns the reachabilityDistance for this dataObject

Specified by:
  `getReachabilityDistance` in interface `DataObject`

### toString

public String toString()

Overrides:
  `toString` in class `Object`

### getRevision

public String getRevision()
Returns the revision string.

Specified by:
  `getRevision` in interface `RevisionHandler`
Returns:
  the revision